Meet in the middle algorithm

This video explains the meet in the middle algorithm which is a very unique algorithm used to find the closest subsequence sum. It requires you to know finding all possible subset sums and use of binary search lowerbound. A practice problem for this algo is leetcode 1755.
CODE LINK is present below as usual. If you find any difficulty or have any query then do COMMENT below. PLEASE help our channel by SUBSCRIBING and LIKE our video if you found it helpful...CYA :)
======================================PLEASE DONATE=============================
🧡 SUPPORT OUR WORK: / techdose
💚 UPI-ID: surya.kahar@ybl
💞JOIN Membership: / @techdose4u
==============================================================================
INSTAGRAM : / surya.pratap.k
LinkedIn: / surya-pratap-kahar-47b...
WEBSITE: techdose.co.in/
TELEGRAM Channel LINK: t.me/codewithTECHDOSE
TELEGRAM Group LINK: t.me/joinchat/SRVOIxWR4sRIVv5...
=======================================================================
USEFUL LINKS:
🟠Must do TIPS to ACE Virtual Interview: • 🔴Must do Tips to ACE y...
🟢Best strategy to excel your coding interview: • 🔴Best strategy to exce...
🟡Get your dream job in 1 month: • 🔴Get your dream job in...
🔵How to crack dream job in just 2 months: • How to crack dream job...
🟣7 Days DSA plan: techdose.co.in/7-days-dsa-che...
RELATED LINKS:
CODE LINK: gist.github.com/SuryaPratapK/...

Пікірлер: 30

  • @saumyaranjan9256
    @saumyaranjan9256 Жыл бұрын

    Really clear and concise on the explanation part. The thing which helped most was the way in which you had prepared the notes beforehand and they really addressed every part of the problem and the algorithm as to why is it beneficial to use this in this particular case. Thank You!

  • @sumitkumarmahto5081
    @sumitkumarmahto50816 ай бұрын

    The video's Heading is Meet in the middle algorithm, but you never really explained why this is called meet in the middle algorithm ? what is the intuition behind it ? how can this idea be generalized to other such problems ?

  • @jui20oct
    @jui20oct6 ай бұрын

    Very clear explanation! Thank you!

  • @shivanggautam541
    @shivanggautam5419 ай бұрын

    very understandable and amazing explanation. thank you very much for the video

  • @surendharv795
    @surendharv795Ай бұрын

    4:04 Sir, One Small correction in the video. The closeset sum can be great than the goal , but should be closest.

  • @casinarro
    @casinarro Жыл бұрын

    really neat and systematic explanation. This channel is a gem!! Thanks a lot, will continue watching and refer the channel to my friends.

  • @techdose4u

    @techdose4u

    Жыл бұрын

    Welcome :)

  • @hijibiji9471
    @hijibiji9471 Жыл бұрын

    lower_bound definition is different if compared with lower_bound stl of cpp

  • @HimanshuSingh-rm5sd

    @HimanshuSingh-rm5sd

    10 ай бұрын

    yes it gives arr[i] > = target with smallest i value

  • @bharat_india12
    @bharat_india12 Жыл бұрын

    Good explanation

  • @HimanshuSingh-rm5sd
    @HimanshuSingh-rm5sd10 ай бұрын

    @techdose sir lower_bound definition is different in this case for 13 it wil return n size of array

  • @vivekpatwal4655
    @vivekpatwal46555 ай бұрын

    beautiful sirrr

  • @Lucifer-xt7un
    @Lucifer-xt7un Жыл бұрын

    Sir please please upload a sheet for complete beginners which support to join your course

  • @yogeeshrsyogeeshrs4204
    @yogeeshrsyogeeshrs4204 Жыл бұрын

    Yes I am also requesting you to make videos on greedy technique it will be beneficial in the interview please

  • @techdose4u

    @techdose4u

    Жыл бұрын

    Sure

  • @kushalkushal8458
    @kushalkushal845811 ай бұрын

    Thanks a lot

  • @sdmfslkdm
    @sdmfslkdm6 ай бұрын

    how does deviding the arrray into two parts explore all subset sums ? for eg -> 3 + (-2) = 1 is missing !

  • @techdose4u

    @techdose4u

    6 ай бұрын

    What’s your example? Please elaborate

  • @sonumondal9376
    @sonumondal9376 Жыл бұрын

    One request sir your videos are really beneficial but can you make more videos for greedy playlist plzzz plzz

  • @techdose4u

    @techdose4u

    Жыл бұрын

    noted

  • @jatinarora2991
    @jatinarora29919 ай бұрын

    why subset sum is not a feasible soln can you explain. If we use binary seach with subset sum(using dp) then it can be solved in log(sum)*sum*N right ?

  • @techdose4u

    @techdose4u

    9 ай бұрын

    Space complexity ?

  • @ayushsaxena5505
    @ayushsaxena5505 Жыл бұрын

    In the code why have you also used the previous element of the lower bound

  • @harisai3580
    @harisai35806 ай бұрын

    Anybody seeing my comment pls answer my doubt that is subset sum problem works only for positive numbers right or it works for any integers ? pls........

  • @techdose4u

    @techdose4u

    6 ай бұрын

    It can be made to work but the complexity will be much more. Ex. (-2,-4,2,3) Sum range will be -6 to 5 (taking extreme subset sum scenarios). Now, cols must denote sum. So, No of cols = mod(6)+mod(5)+1(for 0) = 12 cols -6 will be made to map to 0. You can note that space complexity is large. If a sum goes beyond target sum still it can come back due to negative numbers ahead. Therefore, if you give enough space then YES you can solve it :) Peace!

  • @amboojmittal2993
    @amboojmittal2993 Жыл бұрын

    We have considered time complexcity of sorting the right half

  • @techdose4u

    @techdose4u

    Жыл бұрын

    Yes

  • @siddharth892
    @siddharth8926 ай бұрын

    Why would the dp not work though?

  • @AnujGupta-xi5ep

    @AnujGupta-xi5ep

    4 ай бұрын

    For negative elements in the array, dp matrix can't store negative index, hence it won't work.

Келесі